#ifndef GRAPHICS_LIBRARY
#define GRAPHICS_LIBRARY

#include "ezdraw.h"

void openWindow();               // initialize drawing surface
void viewWindow();               // wait until a key is pressed
void eraseWindow();              // erase the drawing window
void closeWindow();              // close the drawing surface

void delayWindow(double secs);   // wait secs seconds before
                                 // executing next instruction
bool keyPress();                 // return true if a key pressed;
                                 // otherwise, return false

// ***********************************************************
//      graphic functions implementation
// ***********************************************************

void openWindow()
{
   ezdInitialize();
}

void viewWindow()
{
   ezdWaitForKeyPress();
}

void eraseWindow()
{
   ezdClearDrawSurface();
}

void closeWindow()
{
   ezdCleanUp();
}

void delayWindow(double secs)
{
   ezdWait((EZDUINT)(secs * 1000));
}

bool keyPress()
{
   if (ezdKeyPress() != 0)
      return true;
   else
      return false;
}

#endif   // GRAPHICS_LIBRARY
