// Ford & Topp shape library demo file
// Starter file for Comp 272 program 3

#include <iostream>
#include <vector>
#include <string>

//#define Vector vector		// don't ask
//#define String string

using namespace std;

#include "graphlib.h"      // for openWindow(), etc.
#include "circlesh.h"      // use CircleShape class
#include "regpolysh.h"        // use RegPolyShape class
#include "rectsh.h"

//#include "drectsh.h"	// pld double rect

class TriangleShape: public RegPolyShape {
public:
	TriangleShape(double x, double y, double len, ShapeColor c = darkgray)
		: RegPolyShape(x,y,3,len,c) 
	{}
};

// declaration of polygonShape class with base class Shape
// this is for irregular polygons
class PolyShape2: public Shape
{
   private:
      int _n;            // number of sides

      // x and y-coordinates of the vertices; 
	  // existing draw() works with these automagically
      vector<double> _point_X;
      vector<double> _point_Y;

   public:
      // constructor. has arguments for the base point,
      // number of sides, the length of each side and the
      // color
      PolyShape2(vector<Point> Ps, ShapeColor c = darkgray);

       // retrieve or set number of sides
	  int getN() {return _n;}

      // draw the polygon
      virtual void draw();
};

// ***********************************************************
//      PolyShape2 class implementation
//		To be completed to implement IRREGULAR polygons
// ***********************************************************


// initialize base class, the number of sides
// and the length of each side
PolyShape2::PolyShape2(vector<Point> Ps, ShapeColor c):
	Shape(Ps[0].x(), Ps[0].y(), c), _n(Ps.size())
{
	// now initialize point_X, point_Y appropriately
}

// don't touch this!!!
void PolyShape2::draw()
{
   EZDCOLORVAL old_color;
   
   // build the polygon's points and draw it
   //buildPoints();
   old_color = ezdSetColor(getColor().convertToEzdColor());
   double *X = (double *) malloc(_n*sizeof(double));
   double *Y = (double *) malloc(_n*sizeof(double));
   for (int i=0; i<_n; i++) X[i]=_point_X[i];
   for (int i=0; i<_n; i++) Y[i]=_point_Y[i];
   setHandle(ezdDrawPolygon(_n, X, Y));
   delete X;
   delete Y;
   ezdSetColor(old_color);
}


class GroupShape : public Shape {
private:
	vector<Shape *> _shapes;
public:
	GroupShape(ShapeColor c) : Shape(0,0,c), _shapes(0) {}

	void addShape(Shape* s) {
		// set color of s to Shape::getColor()??
		_shapes.push_back(s);
	}

	void draw() {
		for (unsigned i=0; i<_shapes.size(); i++) {
			_shapes[i]->draw();
		}
	}
};

int main()
{
   // pointers in the Shape (base) class
   Shape *one, *two, *three;
   vector<Shape*> v(0);

   one = new CircleShape(1.5, 1.75,.25, blue);	
   v.push_back(one);

   two = new RegPolyShape(3, 1, 9, .5, lightblue);
   v.push_back(two);

   Shape* tri = new RegPolyShape(6,1,3,1.4,teal);
   v.push_back(tri);

   v.push_back(new TriangleShape(1,5.5,1.6, yellow));


   three = new CircleShape(5, 6, 2, turquoise);
   v.push_back(three);

   Shape * r = new RectShape(6, 8, 2, 3, green);
   v.push_back(r);

   v.push_back(new RegPolyShape(4, 3, 4, 2, purple));

   // I've included this array of points just for the L of it.
   // Use it to initialize a PolyShape2, if you wish.
   Point PA[] = 
				{Point(2.0, 2.0),
				 Point(2.0, 5.0),
				 Point(3.8, 5.0),
				 Point(3.8, 4.4),
				 Point(2.4, 4.4),
				 Point(2.4, 2.0)};

   int PASIZE = sizeof(PA)/sizeof(Point);

   vector<Point> PV(PASIZE);

   for(int i = 0; i<PASIZE; i++) PV[i]=PA[i];

   // end of L points

   // sample GroupShape, also just here for the L of it
   GroupShape * g = new GroupShape(blue);
   g->addShape(new RectShape(1.5,5.0,1,3.5, blue));
   g->addShape(new RectShape(1.5,8.5,3,1, blue));

   v.push_back(g);

   // open the drawing window
   openWindow();
    
   cout << "about to draw!" << endl;

   for (unsigned i=0; i<v.size(); i++)
	   v[i]->draw();
   // pause to view the figures and close the window
   viewWindow();
   closeWindow();

   return 0;
}
